diff -urN ../VisualBoyAdvance-1.7.2/src/sdl/debugger.cpp ./src/sdl/debugger.cpp
--- ../VisualBoyAdvance-1.7.2/src/sdl/debugger.cpp	2004-05-13 23:13:14 +0900
+++ ./src/sdl/debugger.cpp	2006-08-25 23:00:49 +0900
@@ -985,15 +1174,187 @@
     int n = 0;
     sscanf(args[2], "%d", &n);
     
-    if(address < 0x2000000 || address > 0x3007fff) {
-      printf("Invalid address: %08x\n", address);
+	  if (! ((address >= 0x02000000 && address < 0x02040000) ||
+		    (address >= 0x03000000 && address < 0x03008000) ||
+        (address >= 0x05000000 && address < 0x05000400) ||
+  		  (address >= 0x06000000 && address < 0x06018000) ||
+        (address >= 0x07000000 && address < 0x07000400))) { 
+	    printf("Invalid address: %08x\n", address);
+        return;
+    }
+
+    u32 final = address + n;
+
+    if(address < 0x2040000 && final > 0x2040000) {
+      printf("Invalid byte count: %d\n", n);
+      return;
+    } else if(address < 0x3008000 && final > 0x3008000) {
+      printf("Invalid byte count: %d\n", n);
       return;
+    } else if(address < 0x05000400 && final > 0x05000400) {
+      printf("Invalid byte count: %d\n", n);
+      return;
+    } else if(address < 0x06018000 && final > 0x06018000) {
+      printf("Invalid byte count: %d\n", n);
+      return;
+    } else if(address < 0x07000400 && final > 0x07000400) {
+      printf("Invalid byte count: %d\n", n);
+      return;
+    }
+
+    printf("Added break on write at %08x for %d bytes\n", address, n);
+
+    switch(address >> 24) {
+      case 2:
+        for (int i = 0; i < n; i++)
+          freezeWorkRAM[(address + i) & 0x3ffff] = 1;
+        break;
+      case 3:
+        for (int i = 0; i < n; i++)
+          freezeInternalRAM[(address + i) & 0x7fff] = 1;
+        break;
+      case 5:
+        for (int i = 0; i < n; i++)
+          freezePRAM[(address + i) & 0x3ff] = 1;
+        break;
+      case 6:
+        // address/range must be valid, so we can use a lazy mask
+        for (int i = 0; i < n; i++)
+          freezeVRAM[(address + i) & 0x1ffff] = 1;
+        break;
+      case 7:
+        for (int i = 0; i < n; i++)
+          freezeOAM[(address + i) & 0x3ff] = 1;
+        break;
+    }
+   
+  } else
+    debuggerUsage("bpw");    
+}
+
+static void debuggerBreakChangeClear(int n, char **args)
+{
+  if(n == 3) {
+    u32 address = 0;
+    sscanf(args[1], "%x", &address);
+    int n = 0;
+    sscanf(args[2], "%d", &n);
+    
+	  if (! ((address >= 0x02000000 && address < 0x02040000) ||
+		    (address >= 0x03000000 && address < 0x03008000) ||
+        (address >= 0x05000000 && address < 0x05000400) ||
+  		  (address >= 0x06000000 && address < 0x06018000) ||
+        (address >= 0x07000000 && address < 0x07000400))) { 
+	    printf("Invalid address: %08x\n", address);
+        return;
+    }
+    
+    u32 final = address + n;    
+    switch(address >> 24) {
+    case 2:
+      {
+        address &= 0x3ffff;
+        final &= 0x3ffff;
+        for(u32 i = address; i < final; i++)
+          if(freezeWorkRAM[i] == 2)
+            freezeWorkRAM[i] = 0;
+        printf("Cleared break on change from %08x to %08x\n",
+               0x2000000+address, 0x2000000+final);
+      }
+      break;
+    case 3:
+      {
+        address &= 0x7fff;
+        final &= 0x7fff;
+        for(u32 i = address; i < final; i++)
+          if(freezeInternalRAM[i] == 2)
+            freezeInternalRAM[i] = 0;
+        printf("Cleared break on change from %08x to %08x\n",
+               0x3000000+address, 0x3000000+final);
+      }
+      break;
+    case 5:
+      {
+        address &= 0x3ff;
+        final &= 0x3ff;
+        for(u32 i = address; i < final; i++)
+          if(freezePRAM[i] == 2)
+            freezePRAM[i] = 0;
+        printf("Cleared break on change from %08x to %08x\n",
+               0x5000000+address, 0x5000000+final);
+      }
+      break;
+    case 6:
+      {
+        if (address > 0x6010000) {
+          address &= 0x17fff;
+          final &= 0x17fff;
+        } else {
+          address &= 0xffff;
+          final &= 0xffff;
+        }
+        for(u32 i = address; i < final; i++)
+          if(freezeVRAM[i] == 2)
+            freezeVRAM[i] = 0;
+        printf("Cleared break on change from %08x to %08x\n",
+               0x3000000+address, 0x3000000+final);
+      }
+      break;
+    case 7:
+      {
+        address &= 0x3ff;
+        final &= 0x3ff;
+        for(u32 i = address; i < final; i++)
+          if(freezeOAM[i] == 2)
+            freezeOAM[i] = 0;
+        printf("Cleared break on change from %08x to %08x\n",
+               0x7000000+address, 0x7000000+final);
+      }
+      break;
     }
+  } else if(n == 1) {
+    int i;
+    for(i = 0; i < 0x40000; i++)
+      if(freezeWorkRAM[i] == 2)
+        freezeWorkRAM[i] = 0;
+    for(i = 0; i < 0x8000; i++)
+      if(freezeInternalRAM[i] == 2)
+        freezeInternalRAM[i] = 0;
+    for(i = 0; i < 0x400; i++)
+      if(freezePRAM[i] == 2)
+        freezePRAM[i] = 0;
+    for(i = 0; i < 0x18000; i++)
+      if(freezeVRAM[i] == 2)
+        freezeVRAM[i] = 0;
+    for(i = 0; i < 0x400; i++)
+      if(freezeOAM[i] == 2)
+        freezeOAM[i] = 0;
     
-    if(address > 0x203ffff && address < 0x3000000) {
-      printf("Invalid address: %08x\n", address);
+    printf("Cleared all break on change\n");
+  } else
+    debuggerUsage("bpcc");
+}
+
+static void debuggerBreakChange(int n, char **args)
+{
+  if(n == 3) {
+    if(cheatsNumber != 0) {
+      printf("Cheats are enabled. Cannot continue.\n");
       return;
     }
+    u32 address = 0;
+    sscanf(args[1], "%x", &address);
+    int n = 0;
+    sscanf(args[2], "%d", &n);
+    
+	  if (! ((address >= 0x02000000 && address < 0x02040000) ||
+		    (address >= 0x03000000 && address < 0x03008000) ||
+        (address >= 0x05000000 && address < 0x05000400) ||
+  		  (address >= 0x06000000 && address < 0x06018000) ||
+        (address >= 0x07000000 && address < 0x07000400))) { 
+	    printf("Invalid address: %08x\n", address);
+        return;
+    }
 
     u32 final = address + n;
 
@@ -1003,22 +1364,84 @@
     } else if(address < 0x3008000 && final > 0x3008000) {
       printf("Invalid byte count: %d\n", n);
       return;
+    } else if(address < 0x6018000 && final > 0x6018000) {
+      printf("Invalid byte count: %d\n", n);
+      return;
+    } else if(address < 0x7000400 && final > 0x7000400) {
+      printf("Invalid byte count: %d\n", n);
+      return;
     }
-    printf("Added break on write at %08x for %d bytes\n", address, n);
-    for(int i = 0; i < n; i++) {
-      if((address >> 24) == 2)
-        freezeWorkRAM[address & 0x3ffff] = true;
-      else
-        freezeInternalRAM[address & 0x7fff] = true;
-      address++;
+    printf("Added break on change at %08x for %d bytes\n", address, n);
+    
+    switch(address >> 24) {
+      case 2:
+        for (int i = 0; i < n; i++)
+          freezeWorkRAM[(address + i) & 0x3ffff] = 2;
+        break;
+      case 3:
+        for (int i = 0; i < n; i++)
+          freezeInternalRAM[(address + i) & 0x7fff] = 2;
+        break;
+      case 5:
+        for (int i = 0; i < n; i++)
+          freezePRAM[(address + i) & 0x3ff] = 2;
+        break;
+      case 6:
+        // address/range must be valid, so we can use a lazy mask
+        for (int i = 0; i < n; i++)
+          freezeVRAM[(address + i) & 0x1ffff] = 2;
+        break;
+      case 7:
+        for (int i = 0; i < n; i++)
+          freezeOAM[(address + i) & 0x3ff] = 2;
+        break;
     }
+
   } else
-    debuggerUsage("bpw");    
+    debuggerUsage("bpc");
+}
+
+static void debuggerDisassembleArm(FILE *f, u32 pc, int count)
+{
+  char buffer[80];
+  int i = 0;
+  u32 len = 0;
+  char format[30];
+  for(i = 0; i < count; i++) {
+    size_t l = strlen(elfGetAddressSymbol(pc+4*i));
+    if(l > len)
+      len = l;
+  }
+  sprintf(format, "%%08x %%-%ds %%s\n", len);
+  for(i = 0; i < count; i++) {
+    u32 addr = pc;
+    pc += disArm(pc, buffer, 2);
+    fprintf(f, format, addr, elfGetAddressSymbol(addr), buffer);
+  }
 }
 
-void debuggerDisassembleArm(int n, char **args)
+static void debuggerDisassembleThumb(FILE *f, u32 pc, int count)
 {
   char buffer[80];
+  int i = 0;
+  u32 len = 0;
+  char format[30];
+  for(i = 0; i < count; i++) {
+    size_t l = strlen(elfGetAddressSymbol(pc+2*i));
+    if(l > len)
+      len = l;
+  }
+  sprintf(format, "%%08x %%-%ds %%s\n", len);  
+  
+  for(i = 0; i < count; i++) {
+    u32 addr = pc;
+    pc += disThumb(pc, buffer, 2);
+    fprintf(f, format, addr, elfGetAddressSymbol(addr), buffer);
+  }
+}
+
+static void debuggerDisassembleArm(int n, char **args)
+{
   u32 pc = reg[15].I;
   pc -= 4;
   int count = 20;
@@ -1032,25 +1455,11 @@
   if(n >= 3) {
     sscanf(args[2], "%d", &count);
   }
-  int i = 0;
-  int len = 0;
-  char format[30];
-  for(i = 0; i < count; i++) {
-    int l = strlen(elfGetAddressSymbol(pc+4*i));
-    if(l > len)
-      len = l;
-  }
-  sprintf(format, "%%08x %%-%ds %%s\n", len);
-  for(i = 0; i < count; i++) {
-    u32 addr = pc;
-    pc += disArm(pc, buffer, 2);
-    printf(format, addr, elfGetAddressSymbol(addr), buffer);
-  }
+  debuggerDisassembleArm(stdout, pc, count); 
 }
 
-void debuggerDisassembleThumb(int n, char **args)
+static void debuggerDisassembleThumb(int n, char **args)
 {
-  char buffer[80];
   u32 pc = reg[15].I;
   pc -= 2;
   int count = 20;
@@ -1064,25 +1473,10 @@
   if(n >= 3) {
     sscanf(args[2], "%d", &count);
   }
-
-  int i = 0;
-  int len = 0;
-  char format[30];
-  for(i = 0; i < count; i++) {
-    int l = strlen(elfGetAddressSymbol(pc+2*i));
-    if(l > len)
-      len = l;
-  }
-  sprintf(format, "%%08x %%-%ds %%s\n", len);  
-  
-  for(i = 0; i < count; i++) {
-    u32 addr = pc;
-    pc += disThumb(pc, buffer, 2);
-    printf(format, addr, elfGetAddressSymbol(addr), buffer);
-  }
+  debuggerDisassembleThumb(stdout, pc, count);
 }
 
-void debuggerDisassemble(int n, char **args)
+static void debuggerDisassemble(int n, char **args)
 {
   if(armState)
     debuggerDisassembleArm(n, args);
@@ -1090,19 +1484,306 @@
     debuggerDisassembleThumb(n, args);
 }
 
-void debuggerContinueAfterBreakpoint()
+static void debuggerFileDisassembleArm(int n, char **args)
+{
+  u32 pc = reg[15].I;
+  pc -= 4;
+  int count = 20;
+  if(n < 2) {
+    debuggerUsage("fda");
+    return;
+  }
+  FILE *f = fopen(args[1], "w+");
+  if(!f) {
+    printf("Error: cannot open file %s\n", args[1]);
+    return;
+  }
+  if(n >= 3) {
+    sscanf(args[2], "%x", &pc);
+  }
+  if(pc & 3) {
+    printf("Misaligned address %08x\n", pc);
+    pc &= 0xfffffffc;
+  }
+  if(n >= 4) {
+    sscanf(args[3], "%d", &count);
+  }
+  debuggerDisassembleArm(f, pc, count); 
+  fclose(f);
+}
+
+static void debuggerFileDisassembleThumb(int n, char **args)
+{
+  u32 pc = reg[15].I;
+  pc -= 2;
+  int count = 20;
+  if(n < 2) {
+    debuggerUsage("fdt");
+    return;
+  }
+  FILE *f = fopen(args[1], "w+");
+  if(!f) {
+    printf("Error: cannot open file %s\n", args[1]);
+    return;
+  }
+    
+  if(n >= 3) {
+    sscanf(args[2], "%x", &pc);
+  }
+  if(pc & 1) {
+    printf("Misaligned address %08x\n", pc);
+    pc &= 0xfffffffe;
+  }
+  if(n >= 4) {
+    sscanf(args[3], "%d", &count);
+  }
+  debuggerDisassembleThumb(f, pc, count);
+  fclose(f);
+}
+
+void debuggerFindText(int n, char **args)
+{
+  if ((n == 4) || (n == 3))
+  {
+    SearchResults = 0;
+    sscanf(args[1], "%x", &SearchStart);
+    
+    if (n == 4)
+	{
+      sscanf(args[2], "%u", &SearchMaxMatches);
+      strncpy((char*) SearchData, args[3], 64);
+	  SearchLength = strlen(args[3]);
+	}
+	else if (n == 3)
+	{
+      strncpy((char*) SearchData, args[2], 64);
+	  SearchLength = strlen(args[2]);
+	};
+
+	if (SearchLength > 64)
+	{
+	  printf ("Entered string (length: %d) is longer than 64 bytes and was cut.\n", SearchLength);
+	  SearchLength = 64;
+	};
+
+	debuggerDoSearch ();
+    
+  } else
+    debuggerUsage("ft");
+};
+
+void debuggerFindHex(int n, char **args)
+{
+  if ((n == 4) || (n == 3))
+  {
+    SearchResults = 0;
+    sscanf(args[1], "%x", &SearchStart);
+    
+	char SearchHex [128];
+    if (n == 4)
+	{
+      sscanf(args[2], "%u", &SearchMaxMatches);
+      strncpy(SearchHex, args[3], 128);
+	  SearchLength = strlen(args[3]);
+	}
+	else if (n == 3)
+	{
+      strncpy(SearchHex, args[2], 128);
+	  SearchLength = strlen(args[2]);
+	};
+
+	if (SearchLength & 1)
+	  printf ("Unaligned bytecount: %d,5. Last digit (%c) cut.\n", SearchLength / 2, SearchHex [SearchLength - 1]);
+
+	SearchLength /= 2;
+
+	if (SearchLength > 64)
+	{
+	  printf ("Entered string (length: %d) is longer than 64 bytes and was cut.\n", SearchLength);
+	  SearchLength = 64;
+	};
+
+	for (unsigned int i = 0; i < SearchLength; i++)
+	{
+	  unsigned int cbuf = 0;
+	  sscanf (&SearchHex [i << 1], "%02x", &cbuf);
+      SearchData [i] = cbuf;
+	};
+    
+	debuggerDoSearch ();
+    
+  } else
+    debuggerUsage("fh");
+};
+
+void debuggerFindResume(int n, char **args)
+{
+  if ((n == 1) || (n == 2))
+  {
+    if (SearchLength == 0)
+	{
+	  printf("Error: No search in progress. Start a search with ft or fh.\n");
+      debuggerUsage("fr");
+	  return;
+	};
+    
+	if (n == 2)
+	  sscanf(args[1], "%u", &SearchMaxMatches);
+    
+	debuggerDoSearch();
+
+  } else
+    debuggerUsage("fr");
+};
+
+void debuggerDoSearch()
+{
+  int count = 0;
+
+  while (true)
+  {
+    unsigned int final = SearchStart + SearchLength - 1;
+    u8* end;
+    u8* start;
+
+    switch (SearchStart >> 24)
+    {
+    case 0:
+      if (final > 0x00003FFF) { SearchStart = 0x02000000; continue; }
+        else { start = bios + (SearchStart & 0x3FFF); end = bios + 0x3FFF; break; };
+    case 2:
+      if (final > 0x0203FFFF) { SearchStart = 0x03000000; continue; }
+        else { start = workRAM + (SearchStart & 0x3FFFF); end = workRAM + 0x3FFFF; break; };
+    case 3:
+      if (final > 0x03007FFF) { SearchStart = 0x04000000; continue; }
+        else { start = internalRAM + (SearchStart & 0x7FFF); end = internalRAM + 0x7FFF; break; };
+    case 4:
+      if (final > 0x040003FF) { SearchStart = 0x05000000; continue; }
+        else { start = ioMem + (SearchStart & 0x3FF); end = ioMem + 0x3FF; break; };
+    case 5:
+      if (final > 0x050003FF) { SearchStart = 0x06000000; continue; }
+        else { start = paletteRAM + (SearchStart & 0x3FF); end = paletteRAM + 0x3FF; break; };
+    case 6:
+      if (final > 0x0601FFFF) { SearchStart = 0x07000000; continue; }
+        else { start = vram + (SearchStart & 0x1FFFF); end = vram + 0x1FFFF; break; };
+    case 7:
+      if (final > 0x070003FF) { SearchStart = 0x08000000; continue; }
+        else { start = oam + (SearchStart & 0x3FF); end = oam + 0x3FF; break; };
+    case 8:
+    case 9:
+    case 10:
+    case 11:
+    case 12:
+    case 13:
+	  if (final <= 0x09FFFFFF)
+		{ start = rom + (SearchStart & 0x01FFFFFF); end = rom + 0x01FFFFFF; break; };
+	default:
+      printf ("Search completed.\n");
+      SearchLength = 0;
+      return;
+    };
+
+    end -= SearchLength - 1;
+    u8 firstbyte = SearchData [0];
+    while (start <= end)
+    {
+      while ((start <= end) && (*start != firstbyte))
+        start++;
+
+      if (start > end)
+        break;
+
+      unsigned int p = 1;
+      while ((start [p] == SearchData [p]) && (p < SearchLength))
+        p++;
+
+      if (p == SearchLength)
+      {
+        printf ("Search result (%d): %08x\n", count + SearchResults, AddressToGBA (start));
+        count++;
+        if (count == SearchMaxMatches)
+        {
+          SearchStart = AddressToGBA (start + p);
+		  SearchResults += count;
+          return;
+        };
+
+        start += p;		// assume areas don't overlap; alternative: start++;
+      } else
+        start++;
+    };
+
+    SearchStart = AddressToGBA (end + SearchLength - 1) + 1;
+  };
+};
+
+unsigned int AddressToGBA(u8* mem)
+{
+  if(mem >= &bios[0] && mem <= &bios[0x3fff])
+    return 0x00000000 + (mem - &bios[0]);
+  else if(mem >= &workRAM[0] && mem <= &workRAM[0x3ffff])
+    return 0x02000000 + (mem - &workRAM[0]);
+  else if(mem >= &internalRAM[0] && mem <= &internalRAM[0x7fff])
+    return 0x03000000 + (mem - &internalRAM[0]);
+  else if(mem >= &ioMem[0] && mem <= &ioMem[0x3ff])
+    return 0x04000000 + (mem - &ioMem[0]);
+  else if(mem >= &paletteRAM[0] && mem <= &paletteRAM[0x3ff])
+    return 0x05000000 + (mem - &paletteRAM[0]);
+  else if(mem >= &vram[0] && mem <= &vram[0x1ffff])
+    return 0x06000000 + (mem - &vram[0]);
+  else if(mem >= &oam[0] && mem <= &oam[0x3ff])
+    return 0x07000000 + (mem - &oam[0]);
+  else if(mem >= &rom[0] && mem <= &rom[0x1ffffff])
+    return 0x08000000 + (mem - &rom[0]);
+  else
+    return 0xFFFFFFFF;
+};
+
+static void debuggerFileDisassemble(int n, char **args)
+{
+  if(n < 2) {
+    debuggerUsage("fd");
+  } else {
+    if(armState)
+      debuggerFileDisassembleArm(n, args);
+    else
+      debuggerFileDisassembleThumb(n, args);
+  }
+}
+
+static void debuggerContinueAfterBreakpoint()
 {
   printf("Continuing after breakpoint\n");
   debuggerEnableBreakpoints(true);
+  debuggerPrefetch();
   emulator.emuMain(1);
   debuggerAtBreakpoint = false;
 }
 
-void debuggerRegisters(int, char **)
+static void debuggerRegisters(int, char **)
 {
   char *command[3];
   char buffer[10];
 
+#ifdef BKPT_SUPPORT
+  if (debugger_last)
+  {
+    printf("R00=%08x R04=%08x R08=%08x R12=%08x\n",
+         oldreg[0], oldreg[4], oldreg[8], oldreg[12]);
+    printf("R01=%08x R05=%08x R09=%08x R13=%08x\n",
+         oldreg[1], oldreg[5], oldreg[9], oldreg[13]);
+    printf("R02=%08x R06=%08x R10=%08x R14=%08x\n",
+         oldreg[2], oldreg[6], oldreg[10], oldreg[14]);
+    printf("R03=%08x R07=%08x R11=%08x R15=%08x\n",
+         oldreg[3], oldreg[7], oldreg[11], oldreg[15]);
+    command[0]="m";
+    command[1]=oldbuffer;
+    command[2]="1";
+    debuggerDisassemble(3, command);
+    printf("\n");
+  }
+#endif
+
   printf("R00=%08x R04=%08x R08=%08x R12=%08x\n",
          reg[0].I, reg[4].I, reg[8].I, reg[12].I);
   printf("R01=%08x R05=%08x R09=%08x R13=%08x\n",
@@ -1128,7 +1809,7 @@
   debuggerDisassemble(3, command);
 }
 
-void debuggerIoVideo()
+static void debuggerIoVideo()
 {
   printf("DISPCNT  = %04x\n", DISPCNT);
   printf("DISPSTAT = %04x\n", DISPSTAT);
@@ -1149,7 +1830,7 @@
   printf("COLY     = %04x\n", COLY);
 }
 
-void debuggerIoVideo2()
+static void debuggerIoVideo2()
 {
   printf("BG0HOFS  = %04x\n", BG0HOFS);
   printf("BG0VOFS  = %04x\n", BG0VOFS);
@@ -1173,7 +1854,7 @@
   printf("BG3Y     = %08x\n", (BG3Y_H<<16)|BG3Y_L);
 }
 
-void debuggerIoDMA()
+static void debuggerIoDMA()
 {
   printf("DM0SAD   = %08x\n", (DM0SAD_H<<16)|DM0SAD_L);
   printf("DM0DAD   = %08x\n", (DM0DAD_H<<16)|DM0DAD_L);
@@ -1189,7 +1870,7 @@
   printf("DM3CNT   = %08x\n", (DM3CNT_H<<16)|DM3CNT_L);    
 }
 
-void debuggerIoTimer()
+static void debuggerIoTimer()
 {
   printf("TM0D     = %04x\n", TM0D);
   printf("TM0CNT   = %04x\n", TM0CNT);
@@ -1201,7 +1882,7 @@
   printf("TM3CNT   = %04x\n", TM3CNT);
 }
 
-void debuggerIoMisc()
+static void debuggerIoMisc()
 {
   printf("P1       = %04x\n", P1);  
   printf("IE       = %04x\n", IE);
@@ -1209,7 +1890,7 @@
   printf("IME      = %04x\n", IME);
 }
 
-void debuggerIo(int n, char **args)
+static void debuggerIo(int n, char **args)
 {
   if(n == 1) {
     debuggerIoVideo();
@@ -1228,11 +1909,11 @@
   else printf("Unrecognized option %s\n", args[1]);
 }
 
-void debuggerEditByte(int n, char **args)
+static void debuggerEditByte(int n, char **args)
 {
   if(n == 3) {
-    u32 address;
-    u32 byte;
+    u32 address = 0x10000;
+    u32 byte = 0;
     sscanf(args[1], "%x", &address);
     sscanf(args[2], "%x", &byte);
     debuggerWriteByte(address, (u8)byte);
@@ -1240,23 +1921,41 @@
     debuggerUsage("eb");    
 }
 
-void debuggerEditHalfWord(int n, char **args)
+static void debuggerEditHalfWord(int n, char **args)
 {
   if(n == 3) {
-    u32 address;
-    u32 byte;
+    u32 address = 0x10000;
+    u32 HalfWord = 0;
     sscanf(args[1], "%x", &address);
     if(address & 1) {
       printf("Error: address must be half-word aligned\n");
       return;
     }
-    sscanf(args[2], "%x", &byte);
-    debuggerWriteHalfWord(address, (u16)byte);
+    sscanf(args[2], "%x", &HalfWord);
+    debuggerWriteHalfWord(address, (u16)HalfWord);
   } else
     debuggerUsage("eh");        
 }
 
-void debuggerEdit(int n, char **args)
+static void debuggerEditRegister(int n, char **args)
+{
+  if(n == 3) {
+    int r = 15;
+    u32 val;
+    sscanf(args[1], "%d", &r);
+    if(r > 16 || r == 15) {
+      // don't allow PC to change
+      printf("Error: Register must be valid (0-14,16)\n");
+      return;
+    }
+    sscanf(args[2], "%x", &val);
+    reg[r].I=val;
+    printf("Register changed.\n");
+  } else
+    debuggerUsage("er");    
+}
+
+static void debuggerEdit(int n, char **args)
 {
   if(n == 3) {
     u32 address;
@@ -1275,12 +1974,12 @@
 
 #define ASCII(c) (c) < 32 ? '.' : (c) > 127 ? '.' : (c)
 
-void debuggerMemoryByte(int n, char **args)
+static void debuggerMemoryByte(int n, char **args)
 {
   if(n == 2) {
     u32 addr = 0;
     sscanf(args[1], "%x", &addr);
-    for(int i = 0; i < 16; i++) {
+    for(int _i = 0; _i < 16; _i++) {
       int a = debuggerReadByte(addr);
       int b = debuggerReadByte(addr+1);
       int c = debuggerReadByte(addr+2);
@@ -1310,13 +2009,13 @@
     debuggerUsage("mb");    
 }
 
-void debuggerMemoryHalfWord(int n, char **args)
+static void debuggerMemoryHalfWord(int n, char **args)
 {
   if(n == 2) {
     u32 addr = 0;
     sscanf(args[1], "%x", &addr);
     addr = addr & 0xfffffffe;
-    for(int i = 0; i < 16; i++) {
+    for(int _i = 0; _i < 16; _i++) {
       int a = debuggerReadByte(addr);
       int b = debuggerReadByte(addr+1);
       int c = debuggerReadByte(addr+2);
@@ -1346,13 +2045,13 @@
     debuggerUsage("mh");    
 }
 
-void debuggerMemory(int n, char **args)
+static void debuggerMemory(int n, char **args)
 {
   if(n == 2) {
     u32 addr = 0;
     sscanf(args[1], "%x", &addr);
     addr = addr & 0xfffffffc;
-    for(int i = 0; i < 16; i++) {
+    for(int _i = 0; _i < 16; _i++) {
       int a = debuggerReadByte(addr);
       int b = debuggerReadByte(addr+1);
       int c = debuggerReadByte(addr+2);
@@ -1385,7 +2084,7 @@
     debuggerUsage("mw");    
 }
 
-void debuggerQuit(int, char **)
+static void debuggerQuit(int, char **)
 {
   char buffer[10];
   printf("Are you sure you want to quit (y/n)? ");
